#pragma once
#include <iostream>
#include <sstream>

#include <openvr.h>
#include <glm/mat3x4.hpp>


class SteamTracking
{
private:
	vr::IVRSystem *vr_system_ = nullptr;
	vr::TrackedDevicePose_t tracked_device_poses_[vr::k_unMaxTrackedDeviceCount];


	std::string getDeviceTypeAsString(vr::ETrackedDeviceClass device_class);

	glm::mat3x4* convertMatrix(vr::HmdMatrix34_t in);

	void printMatrix(const vr::HmdMatrix34_t &htm);

public:
	bool debug = false;
	SteamTracking();
	~SteamTracking();

	void printVRDevices();

	glm::mat3x4* getTransformationForDevice(int nDevice);

};

